<!DOCTYPE html>
<html lang='en'>
  <head>
    <meta charset='utf-8'>
      <link rel='stylesheet' href='/style.css'>
      <link rel='icon' type='image/png' sizes='32x32' href='images/favicon-32x32.png'>
      <title>Nils - FBounce</title>
  </head>
  <body>

    <div id='navbar'>
      <a href='/index.html'><img src='images/favicon-32x32.png' alt="Home"></a>
      <a href='/laser.html'>Laser</a>
      <a href='/bounce.html'>Bounce</a>
      <a class='active' href='/functional-bounce.html'>FBounce</a>
      <a href='/collision.html'>Collision</a>
      <a href='/magnetic-field.html'>Magnetic-Field</a>
      <a href='/markov.html'>Markov Chains</a>
      <a href='/mandelbrot.html'>Mandelbrot</a>
      <div class='socials'>
        <a href='https://gitlab.com/_sonsan' target='_blank'><img src='images/GitHub-Mark-Light-32x32.png'></a>
      </div>
    </div>

    <div id='d' style='position:absolute; top:50px;'>
      <canvas id='canvas' width='1200' height='850' style='border:1px'></canvas>
    </div>

    <script>
      const canvas = document.getElementById('canvas');
      const ctx = canvas.getContext('2d');
      const width = canvas.width;
      const height = canvas.height

      const min_size = 10;
      const max_circles = 100;
      const max_vel = 2;
      const circles = [];

      function rndm_int(max) {
        return Math.floor((Math.random() * max) + 10) + 1;
      }

      function rndm_col() {
        let color = '#';
        let digits = '0123456789ABCDEF';
        for (let i = 0; i < 6; i++) {
          color += digits[Math.floor(Math.random() * 16)];
        }
        return color;
      }

      function move() {
        ctx.clearRect(0, 0, canvas.width, canvas.height);
        for (let circle of circles) {
          if (circle.x + circle.size >= width || circle.x - circle.size <= 0) {
            circle.x_dir *= -1; circle.color = rndm_col();
          } else if (circle.y + circle.size >= height || circle.y - circle.size <= 0) {
            circle.y_dir *= -1; circle.color = rndm_col();
          }
          circle.x += circle.x_dir * circle.vel;
          circle.y += circle.y_dir * circle.vel;

          ctx.beginPath();
          ctx.arc(circle.x, circle.y, circle.size, 0, 2*Math.PI);
          ctx.fillStyle = circle.color;
          ctx.fill();
          ctx.stroke();
        }
      }

      function setup() {
        for (let i = 0; i < max_circles; i++) {
          circles.push({x: width/2, y: height/2, color: rndm_col(), vel: rndm_int(max_vel),
            size: rndm_int(20), x_dir: Math.random(), y_dir: Math.random()});
        }
      setInterval(move, 10);
      }
      setup();

    </script>

  </body>
</html>
